<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:elml="http://www.elml.ch" version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2004/07/xpath-functions" xmlns:xdt="http://www.w3.org/2004/07/xpath-datatypes" xmlns:fox="http://xml.apache.org/fop/extensions">
    <xsl:import href="../../../../core/presentation/print/elml.xsl"/>
    <!-- ***** Parameter definitions  *****-->
    <!--The name of this layout (=folder name of template folder!) -->
    <xsl:param name="layout" select="'olat'"/>
    <xsl:param name="pagebreak_level" select="'unit'"/>
    <xsl:param name="contact" select="'info@olat.org'"/>
    <xsl:param name="fop_version" select="'0.9'"/>
    <xsl:param name="fontsize" select="'11pt'"/>
    <!-- <xsl:param name="chapter_numeration" select="'no'"/> -->
    <!-- ***** Template definitions  ***** -->
    <xsl:template name="elml:coverpage">
        <fo:block id="coverpage">
            <fo:block text-align="center">
                    <fo:external-graphic scaling="uniform" id="frentix_logo" width="8cm">
                        <xsl:if test="not($fop_version='0.2')">
                            <xsl:attribute name="content-width">
                                <xsl:text>scale-to-fit</xsl:text>
                            </xsl:attribute>
                        </xsl:if>
                        <xsl:attribute name="src">
                            <xsl:value-of select="$pathRoot"/>
                            <xsl:text>/_templates/</xsl:text>
                            <xsl:value-of select="$layout"/>
                            <xsl:text>/images/frentix_logo_big.png</xsl:text>
                        </xsl:attribute>
                    </fo:external-graphic>
                    <fo:leader leader-pattern="space"/>
            </fo:block>
            <fo:block padding-before="3cm" text-align="center">
                <xsl:choose>
                    <xsl:when test="/elml:lesson/@label='functions'">
                        <fo:external-graphic scaling="uniform" id="olat_logo" width="14cm">
                            <xsl:if test="not($fop_version='0.2')">
                                <xsl:attribute name="content-width">
                                    <xsl:text>scale-to-fit</xsl:text>
                                </xsl:attribute>
                            </xsl:if>
                            <xsl:attribute name="src">
                                <xsl:value-of select="$pathRoot"/>
                                <xsl:text>/_templates/</xsl:text>
                                <xsl:value-of select="$layout"/>
                                <xsl:text>/images/olat_logo2_720.png</xsl:text>
                            </xsl:attribute>
                        </fo:external-graphic>
                    </xsl:when>
                    <xsl:otherwise>
                        <fo:external-graphic scaling="uniform" id="olat_logo" width="14cm">
                            <xsl:if test="not($fop_version='0.2')">
                                <xsl:attribute name="content-width">
                                    <xsl:text>scale-to-fit</xsl:text>
                                </xsl:attribute>
                            </xsl:if>
                            <xsl:attribute name="src">
                                <xsl:value-of select="$pathRoot"/>
                                <xsl:text>/_templates/</xsl:text>
                                <xsl:value-of select="$layout"/>
                                <xsl:text>/images/olat_logo2_720.png</xsl:text>
                            </xsl:attribute>
                        </fo:external-graphic>
                    </xsl:otherwise>
                </xsl:choose>
            </fo:block>
            <fo:block text-align="center" font-size="{$fontsize}*2.5" font-weight="{$fontweighttitle}" line-height="{$lineheight}*2" padding-before="3cm">
                <xsl:choose>
                    <xsl:when test="$multiple='on' and document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/@title">
                        <xsl:value-of select="document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/@title"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="/elml:lesson/@title"/>
                    </xsl:otherwise>
                </xsl:choose>
            </fo:block>
            <fo:block text-align="center" font-size="{$fontsize}*1.5" padding-before="0.5cm">
                <fo:inline font-weight="{$fontweighttitle}">
                    <xsl:value-of select="$server"/>
                </fo:inline>
                <xsl:if test="/elml:lesson/elml:metadata/elml:lessonInfo/elml:lifecycle/elml:version">
                    <xsl:text> - </xsl:text>
                    <xsl:value-of select="month-from-date(/elml:lesson/elml:metadata/elml:lessonInfo/elml:lifecycle/elml:version/@modificationDate)"/>
                    <xsl:text>.</xsl:text>
                    <xsl:value-of select="year-from-date(/elml:lesson/elml:metadata/elml:lessonInfo/elml:lifecycle/elml:version/@modificationDate)"/>
                    <xsl:text> v</xsl:text>
                    <xsl:value-of select="/elml:lesson/elml:metadata/elml:lessonInfo/elml:lifecycle/elml:version"/>
                </xsl:if>
            </fo:block>
        </fo:block>
        <fo:block break-before="page" font-family="Helvetica" font-size="{$fontsize}*0.8">
            <fo:footnote>
                <fo:inline> </fo:inline>
                <fo:footnote-body>
                    <fo:block font-weight="{$fontweighttitle}">@2010 Copyright</fo:block>
                    <fo:block>Some rights reserved! This document is copyright protected by the owners and companies listed below under the Attribution-NonCommercial-ShareAlike Creative Commons license. For more information check:</fo:block>
                    <fo:block>
                        <fo:basic-link color="black" external-destination="http://creativecommons.org/licenses/by-nc-sa/2.5/ch/">http://creativecommons.org/licenses/by-nc-sa/2.5/ch/</fo:basic-link>
                    </fo:block>
                    <fo:block padding-before="3mm">
                        <xsl:value-of select="$name_responsible"/>
                    </fo:block>
                    <fo:block>
                        <xsl:choose>
                            <xsl:when test="$multiple='on' and document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/@authors">
                                <fo:block font-size="{$fontsize}*1.5">
                                    <xsl:value-of select="document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/@authors"/>
                                </fo:block>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:if test="/elml:lesson/elml:metadata/elml:lessonInfo/elml:lifecycle/elml:contribute/elml:person">
                                    <fo:list-block start-indent="inherited-property-value(&apos;start-indent&apos;) + 1mm" provisional-distance-between-starts="8mm" provisional-label-separation="1mm" display-align="before" line-height="{$lineheight}*0.8">
                                        <xsl:for-each select="/elml:lesson/elml:metadata/elml:lessonInfo/elml:lifecycle/elml:contribute/elml:person">
                                            <fo:list-item>
                                                <fo:list-item-label end-indent="label-end()">
                                                    <fo:block font-family="Courier" font-size="{$fontsize}*1.5">&#x2022;</fo:block>
                                                </fo:list-item-label>
                                                <fo:list-item-body start-indent="body-start()">
                                                    <fo:block>
                                                        <xsl:value-of select="@name"/>
                                                        <xsl:text> (</xsl:text>
                                                        <xsl:value-of select="@responsible"/>
                                                        <xsl:text>)</xsl:text>
                                                        <xsl:choose>
                                                            <xsl:when test="@institute='UZH' and $lang='de'">
                                                                <xsl:text>, Universität Zürich</xsl:text>
                                                            </xsl:when>
                                                            <xsl:when test="@institute='UZH'">
                                                                <xsl:text>, University of Zurich</xsl:text>
                                                            </xsl:when>
                                                            <xsl:when test="@institute">
                                                                <xsl:text>, </xsl:text>
                                                                <xsl:value-of select="@institute"/>
                                                            </xsl:when>
                                                        </xsl:choose>
                                                        <xsl:if test="@departement and not(@departement='Other')">
                                                            <xsl:text>, </xsl:text>
                                                            <xsl:value-of select="@departement"/>
                                                        </xsl:if>
                                                        <xsl:if test="@email">
                                                            <xsl:text>, </xsl:text>
                                                            <xsl:value-of select="@email"/>
                                                        </xsl:if>
                                                        <xsl:text> </xsl:text>
                                                        <xsl:apply-templates/>
                                                    </fo:block>
                                                </fo:list-item-body>
                                            </fo:list-item>
                                        </xsl:for-each>
                                    </fo:list-block>
                                </xsl:if>
                            </xsl:otherwise>
                        </xsl:choose>
                    </fo:block>
                    <fo:block text-align="right">
                        <fo:external-graphic scaling="uniform" id="creativecommonslogo" width="88px">
                            <xsl:if test="not($fop_version='0.2')">
                                <xsl:attribute name="content-width">
                                    <xsl:text>scale-to-fit</xsl:text>
                                </xsl:attribute>
                            </xsl:if>
                            <xsl:attribute name="src">
                                <xsl:value-of select="$pathRoot"/>
                                <xsl:text>/_templates/</xsl:text>
                                <xsl:value-of select="$layout"/>
                                <xsl:text>/images/creativecommons.png</xsl:text>
                            </xsl:attribute>
                        </fo:external-graphic>
                    </fo:block>
                </fo:footnote-body>
            </fo:footnote>
        </fo:block>
    </xsl:template>
    <xsl:template name="elml:icons">
        <xsl:choose>
            <xsl:when test="not($layout='none')">
                <fo:table table-layout="fixed" width="100%" border-style="solid" border-width="0.5pt" border-color="white">
                    <fo:table-column column-width="40px"/>
                    <fo:table-column/>
                    <fo:table-body>
                        <fo:table-row>
                            <fo:table-cell padding-right="6pt" display-align="before" width="30px">
                                <fo:block>
                                    <fo:external-graphic scaling="uniform" content-height="30px" content-width="30px" height="30px" width="30px">
                                        <xsl:attribute name="src">
                                            <xsl:value-of select="$pathRoot"/>
                                            <xsl:text>/_templates/</xsl:text>
                                            <xsl:value-of select="$layout"/>
                                            <xsl:text>/icons/</xsl:text>
                                            <xsl:value-of select="@icon"/>
                                            <xsl:text>.png</xsl:text>
                                        </xsl:attribute>
                                    </fo:external-graphic>
                                </fo:block>
                            </fo:table-cell>
                            <fo:table-cell padding="3pt" display-align="before">
                                <xsl:apply-templates select="." mode="icon"/>
                            </fo:table-cell>
                        </fo:table-row>
                    </fo:table-body>
                </fo:table>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="." mode="icon"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="elml:Kapitel_Number">
        <xsl:param name="isnavigation" select="'no'"/>
        <xsl:param name="actual_lesson">
            <xsl:value-of select="/elml:lesson/@label"/>
        </xsl:param>
        <xsl:choose>
            <xsl:when test="/elml:lesson/@label='help' and $chapter_numeration='yes' and (not(name(.)='goals')) and (not(name(.)='index')) and (not(name(.)='entry')) and (not(name(.)='lesson')) and (not(name(.)='clarify' and empty(@title))) and (not(name(.)='look')) and (not(name(.)='act'))">
                <xsl:choose>
                    <xsl:when test="$multiple='on'">
                        <xsl:for-each select="document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/elml:labelname">
                            <xsl:if test="text()=$actual_lesson">
                                <xsl:value-of select="position()"/>
                            </xsl:if>
                        </xsl:for-each>
                        <xsl:text>.</xsl:text>
                        <xsl:number level="multiple" count="elml:unit[(@role eq 'student') or (@role eq $role) or (not (@role))] | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfFigures[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfTables[not(@visible eq 'online') and not(@visible eq 'none')] | elml:bibliography[not(@visible eq 'online') and not(@visible eq 'none')] | elml:metadata[not(@visible eq 'online') and not(@visible eq 'none')] | elml:learningObject | elml:clarify[@title]"/>
                        <xsl:text> </xsl:text>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:number level="multiple" count="elml:unit[(@role eq 'student') or (@role eq $role) or (not (@role))] | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfFigures[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfTables[not(@visible eq 'online') and not(@visible eq 'none')] | elml:bibliography[not(@visible eq 'online') and not(@visible eq 'none')] | elml:metadata[not(@visible eq 'online') and not(@visible eq 'none')] | elml:learningObject | elml:clarify[@title]"/>
                        <xsl:text>. </xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:when test="$chapter_numeration='yes' and (not(name(.)='goals')) and (not(name(.)='index')) and (not(name(.)='entry')) and (not(name(.)='clarify')) and (not(name(.)='lesson')) and (not(name(.)='look')) and (not(name(.)='act'))">
                <xsl:choose>
                    <xsl:when test="$multiple='on'">
                        <xsl:for-each select="document($config_file)/elml:config/elml:modules/elml:course[child::node()=$transformlesson_label]/elml:labelname">
                            <xsl:if test="text()=$actual_lesson">
                                <xsl:value-of select="position()"/>
                            </xsl:if>
                        </xsl:for-each>
                        <xsl:text>.</xsl:text>
                        <xsl:number level="multiple" count="elml:unit[(@role eq 'student') or (@role eq $role) or (not (@role))] | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfFigures[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfTables[not(@visible eq 'online') and not(@visible eq 'none')] | elml:bibliography[not(@visible eq 'online') and not(@visible eq 'none')] | elml:metadata[not(@visible eq 'online') and not(@visible eq 'none')] | elml:learningObject"/>
                        <xsl:text> </xsl:text>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:number level="multiple" count="elml:unit[(@role eq 'student') or (@role eq $role) or (not (@role))] | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfFigures[not(@visible eq 'online') and not(@visible eq 'none')] | elml:listOfTables[not(@visible eq 'online') and not(@visible eq 'none')] | elml:bibliography[not(@visible eq 'online') and not(@visible eq 'none')] | elml:metadata[not(@visible eq 'online') and not(@visible eq 'none')] | elml:learningObject"/>
                        <xsl:text>. </xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="elml:column">
        <xsl:choose>
            <xsl:when test="elml:columnRight/@cssClass='noprint'">
                <fo:block>
                    <xsl:call-template name="elml:Alignment"/>
                    <xsl:apply-templates select="elml:columnLeft/*"/>
                </fo:block>
            </xsl:when>
            <xsl:otherwise>
                <fo:table table-layout="fixed" width="100%" border-style="solid" border-width="1pt" border-color="white">
                    <xsl:call-template name="elml:Label"/>
                    <fo:table-column>
                        <xsl:choose>
                            <xsl:when test="elml:columnLeft/@width">
                                <xsl:attribute name="column-width">
                                    <xsl:choose>
                                        <xsl:when test="elml:columnLeft/@units='percent'">
                                            <xsl:text>proportional-column-width(</xsl:text>
                                            <xsl:value-of select="elml:columnLeft/@width"/>
                                            <xsl:text>)</xsl:text>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:value-of select="(elml:columnLeft/@width) * $converter_pixel_mm"/>
                                            <xsl:text>mm</xsl:text>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:attribute name="column-width">
                                    <xsl:text>proportional-column-width(1)</xsl:text>
                                </xsl:attribute>
                            </xsl:otherwise>
                        </xsl:choose>
                    </fo:table-column>
                    <xsl:if test="elml:columnMiddle">
                        <fo:table-column>
                            <xsl:choose>
                                <xsl:when test="elml:columnMiddle/@width">
                                    <xsl:attribute name="column-width">
                                        <xsl:choose>
                                            <xsl:when test="elml:columnMiddle/@units='percent'">
                                                <xsl:text>proportional-column-width(</xsl:text>
                                                <xsl:value-of select="elml:columnMiddle/@width"/>
                                                <xsl:text>)</xsl:text>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:value-of select="(elml:columnMiddle/@width) * $converter_pixel_mm"/>
                                                <xsl:text>mm</xsl:text>
                                            </xsl:otherwise>
                                        </xsl:choose>
                                    </xsl:attribute>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:attribute name="column-width">
                                        <xsl:text>proportional-column-width(1)</xsl:text>
                                    </xsl:attribute>
                                </xsl:otherwise>
                            </xsl:choose>
                        </fo:table-column>
                    </xsl:if>
                    <fo:table-column>
                        <xsl:choose>
                            <xsl:when test="elml:columnRight/@width">
                                <xsl:attribute name="column-width">
                                    <xsl:choose>
                                        <xsl:when test="elml:columnRight/@units='percent'">
                                            <xsl:text>proportional-column-width(</xsl:text>
                                            <xsl:value-of select="elml:columnRight/@width"/>
                                            <xsl:text>)</xsl:text>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:value-of select="(elml:columnRight/@width) * $converter_pixel_mm"/>
                                            <xsl:text>mm</xsl:text>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                </xsl:attribute>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:attribute name="column-width">
                                    <xsl:text>proportional-column-width(1)</xsl:text>
                                </xsl:attribute>
                            </xsl:otherwise>
                        </xsl:choose>
                    </fo:table-column>
                    <fo:table-body>
                        <fo:table-row keep-together.within-column="always">
                            <xsl:choose>
                                <xsl:when test="elml:columnLeft/@height">
                                    <xsl:attribute name="height">
                                        <xsl:choose>
                                            <xsl:when test="elml:columnLeft/@units='percent'">
                                                <xsl:value-of select="elml:columnLeft/@height"/>
                                                <xsl:text>%</xsl:text>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:value-of select="(elml:columnLeft/@height) * $converter_pixel_mm"/>
                                                <xsl:text>mm</xsl:text>
                                            </xsl:otherwise>
                                        </xsl:choose>
                                    </xsl:attribute>
                                </xsl:when>
                                <xsl:when test="elml:columnMiddle/@height">
                                    <xsl:attribute name="height">
                                        <xsl:choose>
                                            <xsl:when test="elml:columnMiddle/@units='percent'">
                                                <xsl:value-of select="elml:columnMiddle/@height"/>
                                                <xsl:text>%</xsl:text>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:value-of select="(elml:columnMiddle/@height) * $converter_pixel_mm"/>
                                                <xsl:text>mm</xsl:text>
                                            </xsl:otherwise>
                                        </xsl:choose>
                                    </xsl:attribute>
                                </xsl:when>
                                <xsl:when test="elml:columnRight/@height">
                                    <xsl:attribute name="height">
                                        <xsl:choose>
                                            <xsl:when test="elml:columnRight/@units='percent'">
                                                <xsl:value-of select="elml:columnRight/@height"/>
                                                <xsl:text>%</xsl:text>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:value-of select="(elml:columnRight/@height) * $converter_pixel_mm"/>
                                                <xsl:text>mm</xsl:text>
                                            </xsl:otherwise>
                                        </xsl:choose>
                                    </xsl:attribute>
                                </xsl:when>
                            </xsl:choose>
                            <xsl:apply-templates/>
                        </fo:table-row>
                    </fo:table-body>
                </fo:table>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="elml:paragraph" mode="icon">
        <fo:block space-after="{$lineheight}*0.5">
            <xsl:call-template name="elml:Label"/>
            <xsl:choose>
                <xsl:when test="@cssClass='code'">
                    <fo:block font-family="Courier, monospace" font-size="110%" white-space-collapse="true" white-space-treatment="ignore-if-surrounding-linefeed" text-align="left" wrap-option="wrap">
                        <xsl:apply-templates mode="#default"/>
                    </fo:block>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:apply-templates mode="#default"/>
                </xsl:otherwise>
            </xsl:choose>
        </fo:block>
    </xsl:template>
    <xsl:template match="elml:lesson">
        <fo:block>
            <xsl:apply-templates/>
        </fo:block>
    </xsl:template>
    <xsl:template match="elml:lesson" mode="navigation">
        <xsl:apply-templates select="elml:unit | elml:learningObject | elml:selfAssessment | elml:summary | elml:furtherReading | elml:glossary | elml:index | elml:bibliography | elml:listOfFigures | elml:listOfTables" mode="navigation"/>
    </xsl:template>
    <xsl:template match="elml:definition">
        <xsl:param name="term"/>
        <fo:block space-after="{$fontsize}">
            <xsl:if test="not($term)">
                <xsl:attribute name="id">
                    <xsl:value-of select="generate-id()"/>
                </xsl:attribute>
            </xsl:if>
            <fo:inline font-weight="bold">
                <xsl:choose>
                    <xsl:when test="$term">
                        <xsl:value-of select="$term"/>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="@term"/>
                    </xsl:otherwise>
                </xsl:choose>
            </fo:inline>
            <xsl:text>: </xsl:text>
            <xsl:apply-templates/>
            <xsl:call-template name="elml:BibliographyRef"/>
        </fo:block>
    </xsl:template>
</xsl:stylesheet>
