<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:elml="http://www.elml.ch" version="2.0" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns="http://www.w3.org/1999/xhtml" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:import href="../../../core/presentation/online/elml.xsl"/>
	<!-- ***** Parameter definitions  *****-->
	<!--The name of this layout (=folder name of template folder!) -->
	<xsl:param name="layout" select="'plain'"/>
	<!-- ***** Template definitions  ***** -->
	<xsl:template name="elml:LayoutBody">
		<xsl:param name="prev">
			<xsl:call-template name="elml:prev_file"/>
		</xsl:param>
		<xsl:param name="next">
			<xsl:call-template name="elml:next_file"/>
		</xsl:param>
		<body>
		    <xsl:if test="$manifest_type='scorm'">
		        <xsl:attribute name="onunload">
		            <xsl:value-of>finish()</xsl:value-of>
		        </xsl:attribute>
		    </xsl:if>
			<xsl:attribute name="id">
				<xsl:text>body_</xsl:text>
				<xsl:call-template name="elml:Label_param"/>
			</xsl:attribute>
			<xsl:call-template name="elml:LayoutBodySkiplinks"/>
			<div id="page_margins">
				<div id="page">
					<div id="header">
						<div class="navigation_arrows">
							<xsl:choose>
								<xsl:when test="$prev='none.html'">
									<img src="../../../_templates/{$layout}/navigation/back_off.gif" height="12" width="12" alt="No previous page available" border="0"/>
								</xsl:when>
								<xsl:otherwise>
									<a href="{$prev}">
										<img src="../../../_templates/{$layout}/navigation/back.gif" height="12" width="12" alt="Go to previous page" border="0"/>
									</a>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:choose>
								<xsl:when test="$next='none.html'">
									<img src="../../../_templates/{$layout}/navigation/next_off.gif" height="12" width="12" alt="No following page available" border="0"/>
								</xsl:when>
								<xsl:otherwise>
									<a href="{$next}">
										<img src="../../../_templates/{$layout}/navigation/next.gif" height="12" width="12" alt="Go to next page" border="0"/>
									</a>
								</xsl:otherwise>
							</xsl:choose>
						</div>
					</div>
					<xsl:if test="$multiple='on'">
						<!-- #nav: Top Navigation -->
						<div id="nav">
							<div id="nav_main">
								<ul>
									<xsl:call-template name="elml:navigation_top"/>
								</ul>
							</div>
						</div>
						<!-- #nav: - End -->
					</xsl:if>
					<!-- #main: Start Content Part -->
					<div id="main" class="hideboth">
						<!-- #col1: First column contains navigation in eLML -->
						<div id="col1">
							<div id="col1_content" class="clearfix">
								<xsl:call-template name="elml:navigation"/>
							</div>
						</div>
						<!-- #col1: - End -->
						<!-- #col2: Second column contains context information (if available) in eLML 
						<div id="col2">
							<div id="col2_content" class="clearfix">
								<h2>Context Information</h2>
								<p>...</p>
							</div>
							</div>-->
						<!-- #col2: - End -->
						<!-- #col3: Third and variable column contains all the content in eLML -->
						<div id="col3">
							<a id="top" name="top"/>
							<a id="content_link" name="content_link"/>
							<div id="col3_content" class="clearfix">
								<xsl:call-template name="elml:LayoutBodyContent"/>
							</div>
							<!-- IE Column Clearing -->
							<div id="ie_clearing">
								<xsl:text disable-output-escaping="yes"><![CDATA[ &nbsp; ]]></xsl:text>
							</div>
							<!-- End: IE Column Clearing -->
						</div>
						<!-- #col3: - Ende -->
					</div>
					<!-- #main: - End -->
					<!-- #Footer: Begin Footer -->
					<div id="footer">
						<xsl:call-template name="elml:footer"/>
						<div class="navigation_arrows">
							<xsl:choose>
								<xsl:when test="$prev='none.html'">
									<img src="../../../_templates/{$layout}/navigation/back_off.gif" height="12" width="12" alt="No previous page available" border="0"/>
								</xsl:when>
								<xsl:otherwise>
									<a href="{$prev}">
										<img src="../../../_templates/{$layout}/navigation/back.gif" height="12" width="12" alt="Go to previous page" border="0"/>
									</a>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:choose>
								<xsl:when test="$next='none.html'">
									<img src="../../../_templates/{$layout}/navigation/next_off.gif" height="12" width="12" alt="No following page available" border="0"/>
								</xsl:when>
								<xsl:otherwise>
									<a href="{$next}">
										<img src="../../../_templates/{$layout}/navigation/next.gif" height="12" width="12" alt="Go to next page" border="0"/>
									</a>
								</xsl:otherwise>
							</xsl:choose>
						</div>
					</div>
					<!-- #Footer: End -->
				</div>
			</div>
		</body>
	</xsl:template>
</xsl:stylesheet>
